/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  -----------------
  BINSPLIT-Protocol
  -----------------


  Copyright (C)       Johann Hanne, DH3MB, jonny@baycom.org
                      Falkenweg 6
                      D-85122 Hitzhofen

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19990703 DH3MB  Begin of implementation

#include "baycom.h"

#ifdef FEATURE_BINSPLIT

#define BS_MAGIC ">BS<"
#define BINSPLIT_SIZE 20000

/*---------------------------------------------------------------------------*/

class binsplit
{

private:
  void putheaderitem(crcthp *, char *, ...);
  void putheader(char, char);
  char *fname;
  unsigned long int fsize;
  time_t ftime;

public:
  void tx_binsplit(void);

};

/*---------------------------------------------------------------------------*/

void binsplit::putheaderitem(crcthp *headercrc, char *format, ...)
{ va_list argpoint;
  char cbuf[260];
  char *s=cbuf;

  va_start(argpoint,format);
  vsprintf(cbuf,format,argpoint);
  va_end(argpoint);
  if(strlen(s)>257)
  { s[50]=0;
    trace(tr_abbruch,"putbs","long %s",s);
  }
  while(*s)
  { headercrc->update(*s);
    putv(*(s++));
  }

  headercrc->update(LF);
  bputv(LF);
}

/*---------------------------------------------------------------------------*/

void binsplit::putheader(char num, char total)
{ crcthp headercrc;

  putheaderitem(&headercrc, BS_MAGIC);
  putheaderitem(&headercrc, "%02X", num);
  putheaderitem(&headercrc, "%02X", total);
  putheaderitem(&headercrc, "%ld", BINSPLIT_SIZE);
  putheaderitem(&headercrc, "%ld", fsize);
  putheaderitem(&headercrc, "%s", fname);
  putheaderitem(&headercrc, "%s", datestr(ftime, 6));
  bputv(0);
  headercrc.update((char)0);
  bputv(headercrc.result % 0x100);
  bputv(headercrc.result / 0x100);
  bputv(LF);
}

/*---------------------------------------------------------------------------*/

void binsplit::tx_binsplit(void)
{
  char partnum, i;

  if ((ftime = file_isreg (fname)) == 0L)
  { putf(ms(m_filenotfound), fname);
    return;
  }

  fsize=filesize(fname);

  partnum=fsize/BINSPLIT_SIZE;
  if(fsize>partnum*BINSPLIT_SIZE)
    partnum++;

  for(i=1;i<=partnum;i++)
  {



  }


}

/*---------------------------------------------------------------------------*/

#endif
